(in-package #:exercise-timers)

(defparameter *timer-vec* nil)

(defparameter *last-ran* nil)

(defun make-rescheduling-timer-callback (n)
  #'(lambda ()
      (setf (aref *last-ran* n) (now))))

(defun run-auto-rescheduling-timer-test (n s)
  (setf *timer-vec* (make-array n :initial-element nil))
  (setf *last-ran* (make-array n :initial-element nil))
  (loop for i from 0 to (1- n) do
    (let ((new-timer (make-rescheduling-timer-callback i)))
      (setf (aref *timer-vec* i) (sb-ext:make-timer new-timer :name (format nil "Self-rescheduling timer ~A" i) :thread t))
      (sb-ext:schedule-timer (aref *timer-vec* i) s :repeat-interval s))))

(defun check-rescheduling-timers ()
  (every #'identity (loop for i from 0 to (1- (length *timer-vec*)) collecting (sb-ext:timer-scheduled-p (aref *timer-vec* i)))))

(defun whence-rescheduling-timers ()
  (loop for i from 0 to (1- (length *timer-vec*)) collecting (- (timestamp-to-unix (now)) (timestamp-to-unix (aref *last-ran* i)))))

(defun restart-auto-rescheduling-timers ()
  (mapc #'(lambda (i)
	    (sb-ext:schedule-timer (aref *timer-vec* i) 5 :repeat-interval 5))
	(loop for i from 0 to (1- (length *timer-vec*)) when
				 (> (- (timestamp-to-unix (now))
				       (timestamp-to-unix (aref *last-ran* i)))
				    10)
	      collecting i)))
